c MKPE5 @Zitny 4/92
c Reseni Fourierovy Kirchhoffovy rovnice
c
c   u.dT/dx+v.dT/dr= d(a.dT/dx)/dx +d(a.r.dT/dr)dr/r
c
c dvourozmerneho prenosu tepla v cylindr. s.s.
c
c Pouziti bilinearnich obdelnikovych elementu a Gaussovy integrace 2 x 2
c
c Vyznamy poli:
c 2 - noe  [indexy uzlu elementu]
c 3 - xruv [x,r,u,v]  v kazdem uzlu se zadavaji krome souradnic i rychlosti
c 4 - ipu  [indexy parametru uzlu]
c 5 - rpu  [parametry uzlu-teploty]
c 6 -
c 7 - help [textove pole]
c
      common /prop/a  /scom/iss(50)
      external lokal,sext
      character *4 inkey
      equivalence (kbdr,iss(13))
      a=1.
      call scomin(-1)
      call sintro('xmkpe5.for')
      call mtobir('xmkpe5.mat',iend)
10    call sclear
      call minpr(1,' Temperature conductivity a=',28,14,2,a)
1     call mtools(0,sext)
      if(kbdr.eq.67)then
         call mefrin(2,4)
         call mefron(2,4,5,50,4,lokal,0)
      endif
      call grid(kbd)
      if(kbd.eq.62) goto 10
      if(kbd.ne.27) goto 1
      call scwrit(16,2,28,23,' Do You want to Quit ? [Y/N]')
      call skbdr(inkey)
      if(inkey.ne.'Y   '.and.inkey.ne.'y   ')goto 1
999   call sclear
      end

      subroutine lokal(ie,nl,nn,ak,b)
      dimension ak(nl,nl),b(nl),
     / r(8),x(8),u(8),v(8),g(3),w(3),f(8),fx(8),fr(8),temp(8),ibound(8)
      common /prop/a
      data g,w,ngaus/-.77459666,0.,.77459666,
     /.5555555,.8888888,.555555,3/
      call gett4(ie,nl,x,r,u,v,temp,ibound)
      do 1 i=1,nl
        b(i)=0.
        do 1 j=1,nl
1          ak(i,j)=0.
      do 2 ig=1,ngaus
      do 2 jg=1,ngaus
          call fdf(nl,x,r,g(ig),g(jg),f,fx,fr,det)
          rr=0
          uu=0
          vv=0
          do 20 i=1,nl
            rr=rr+r(i)*f(i)
            uu=uu+u(i)*f(i)
20          vv=vv+v(i)*f(i)
          rr=rr*det*w(ig)*w(jg)
          do 3 i=1,nl
          do 3 j=1,nl
3     ak(i,j)=ak(i,j)+rr*(f(i)*(uu*fx(j)+vv*fr(j))+a*(fx(i)*fx(j)+
     /fr(i)*fr(j)))
2     continue
      end

      subroutine fdf(nl,x,r,rksi,rny,f,fx,fr,det)
c vypocet hodnot [f] a derivaci [fx,fr] bazovych funkci v bode rksi,rny.
      dimension x(*),r(*),f(*),fx(*),fr(*),dfksi(8),dfny(8),gx(8),gr(8)
      data gx,gr/-1,1,1,-1,0,1,0,-1,-1,-1,1,1,-1,0,1,0/
      dxksi=0
      dxny =0
      drksi=0
      drny =0
      do 1 i=1,nl
         f(i)=(1+gr(i)*rny)*(1+gx(i)*rksi)/4
         dfksi(i)=gx(i)/4*(1+gr(i)*rny)
         dfny (i)=gr(i)/4*(1+gx(i)*rksi)
         dxksi=dxksi+x(i)*dfksi(i)
         dxny =dxny +x(i)*dfny (i)
         drksi=drksi+r(i)*dfksi(i)
1        drny =drny +r(i)*dfny (i)
      det = dxksi*drny-dxny*drksi
      do 2 i=1,nl
         fx(i)=(drny*dfksi(i)-drksi*dfny(i))/det
2        fr(i)=(dxksi*dfny(i)-dxny*dfksi(i))/det
      end

      subroutine gett4(ie,nl,x,r,u,v,temp,ibound)
c
c data transfer
c
      common z(10000)
      dimension x(8),r(8),u(8),v(8),temp(8),ibound(8),iz(10000)
      equivalence (z,iz)
      call mlocr(2,ie,1,loc,it,np,idif)
      do 1 i=1,nl
         indu=iabs(iz(loc+(i-1)*idif))
         call mlocr(4,indu,1,locp,it,npu,idpu)
         ibound(i)=iz(locp)
         call mlocr(5,iabs(iz(locp)),1,locp,it,npu,idpu)
         temp(i)=z(locp)
         call mlocr(3,indu,1,locp,it,npu,idpu)
         x(i)=z(locp)
         r(i)=z(locp+idpu)
         u(i)=z(locp+2*idpu)
1        v(i)=z(locp+3*idpu)
      end

      subroutine sext(i,itx,j1,j2,ict)
c vysvetlivky jsou v poli cislo 7
      common m(20000) /scom/iss(50)
      character *16 ifile,jfile
      equivalence (lab,m(55)),(nlab,m(62)),(iout,iss(12))
      data ifile/'*.mod'/
      if(ict.eq.54.or.ict.eq.53)then
          call mpanel(1,2,7,7,m(lab+(i-1)*nlab),1,nlab,nlab,m)
          call mpanel(16,2,23,7,
     /    '                                '//
     /    '  Please prepare new data:      '//
     /    '$5Created by COSMOS$[$3F10  $]  '//
     /    '  or manually:                  '//
     /    '$5Select matrix and$[$3Enter$]  '//
     /    '  Start:                        '//
     /    '$5Computation$- by $[$3F9 $  ]  ',7,8,8,m)
      elseif(ict.eq.55)then
          call minpf(1,' File MODINPUT:',15,14,2,ifile,16,10,40,24,
     /               jfile,16,ires)
          if(ires.gt.0)then
             open(30,file=jfile)
             call modinp(30, 2,4, 3,2, 4,1, 5,  0)
C                            iue  ixy  ipu  rp  ipe
             iout=3
             close(30)
          endif
      else
          call medcex(i,itx,j1,j2,ict)
      endif
      end

      subroutine grid(kbd)
c
c graphics
c
      parameter (ntemp=10)
      dimension x(8),r(8),u(8),v(8),temp(8),ibound(8),
     /          itemp(ntemp),vtemp(ntemp)
      character *6 label
      logical contour
      data itemp /2,3,4,5,6,7,8,9,10,11/
      call mpara(2,kod,mat,ne,n,loc,len)
60    xmi=1e10
      xma=-1e10
      rmi=1e10
      rma=-1e10
      uma=1e-10
      tma=1e-10
      do1ie=1,ne
      call gett4(ie,4,x,r,u,v,temp,ibound)
      do1i=1,4
         xmi=amin1(xmi,x(i))
         xma=amax1(xma,x(i))
         rmi=amin1(rmi,r(i))
         rma=amax1(rma,r(i))
         uma=amax1(uma,abs(u(i)))
         tma=amax1(tma,temp(i))
1     continue
      contour=.false.
50    dx=(xma-xmi)*.1
      dr=(rma-rmi)*.1
      scaleu=dx/uma
      scalev=dr/uma
      call gmfin
      call gmfstf(1,0.,1.,0.1,1.,xmi-dx,xma+dx,rmi-dr,rma+dr)
      call scwrit(24,0,73,15,' [F1]-zooming [F2]-zoomout [F3]-contours
     /[F4]-a [Enter]-tools [Esc]-quit')
      call gmfsw(1)
      if(contour)then
          dtemp=tma/(ntemp-1)
          do22i=1,ntemp
22        vtemp(i)=(i-1)*dtemp
          do23ie=1,ne
             call gett4(ie,4,x,r,u,v,temp,ibound)
             x(5)=x(1)
             r(5)=r(1)
             temp(5)=temp(1)
             call gmfer(x,r,temp,vtemp,itemp,ntemp,1)
23        continue
      endif
      do2ie=1,ne
         call gett4(ie,4,x,r,u,v,temp,ibound)
         x(5)=x(1)
         r(5)=r(1)
         call gmfpl(5,x,r,1)
         do2i=4,1,-1
            if(ibound(i).le.0)then
               call gmfmrk(x(i),r(i),16)
            else
               call gmfmrk(x(i),r(i),29)
            endif
            write(label,30)temp(i)
30          format(f6.2)
            call gmftext(x(i),r(i),2,6,label)
            x(i+1)=x(i)+u(i)*scaleu
            r(i+1)=r(i)+v(i)*scalev
            call gmfpl(2,x(i),r(i),4)
2     continue
      call skbdr(kbd)
      if(kbd.eq.59)then
          call gmflcw(xmi,xma,rmi,rma,xmi,xma,rmi,rma,kbd)
          goto 50
      elseif(kbd.eq.60)then
          goto 60
      elseif(kbd.eq.61)then
          contour=.true.
          goto 50
      endif
      call gmfmon
      end
